[From nobody Sun Jan  9 15:52:38 2022
Received: from Debian-exim by ganesha.gnumonks.org with local (Exim 4.72)
 id 1TOo4c-0004nO-OM
 for baseband-devel-bounces@lists.osmocom.org; Thu, 18 Oct 2012 13:15:34 +0200
Date: Thu, 18 Oct 2012 13:15:34 +0200
Message-Id: &lt;E1TOo4c-0004nO-OM@ganesha.gnumonks.org&gt;
X-Failed-Recipients: tianxing@timelink.com.hk
Auto-Submitted: auto-replied
From: Mail Delivery System &lt;Mailer-Daemon@ganesha.gnumonks.org&gt;
To: baseband-devel-bounces@lists.osmocom.org
Subject: Mail delivery failed: returning message to sender

This message was created automatically by mail delivery software.

A message that you sent could not be delivered to one or more of its
recipients. This is a permanent error. The following address(es) failed:

  tianxing@timelink.com.hk
    retry timeout exceeded

------ This is a copy of the message, including all the headers. ------

Return-path: &lt;baseband-devel-bounces@lists.osmocom.org&gt;
Received: from localhost ([127.0.0.1] helo=ganesha.gnumonks.org)
	by ganesha.gnumonks.org with esmtp (Exim 4.72)
	(envelope-from &lt;baseband-devel-bounces@lists.osmocom.org&gt;)
	id 1TOnzG-0002zQ-JB; Thu, 18 Oct 2012 13:10:02 +0200
Received: from uucp by ganesha.gnumonks.org with local-bsmtp (Exim 4.72)
	(envelope-from &lt;laforge@gnumonks.org&gt;)
	id 1TOnnJ-0001cH-Qx; Thu, 18 Oct 2012 12:57:42 +0200
Received: from laforge by nataraja.de.gnumonks.org with local (Exim 4.80)
	(envelope-from &lt;laforge@gnumonks.org&gt;)
	id 1TOn8S-0007gN-OT; Thu, 18 Oct 2012 12:15:28 +0200
Date: Thu, 18 Oct 2012 12:15:28 +0200
From: Harald Welte &lt;laforge@gnumonks.org&gt;
To: =?utf-8?B?4piO?= &lt;Max.Suraev@fairwaves.ru&gt;
Subject: Re: modulo and frame number in mframe_sched.c
Message-ID: &lt;20121018101528.GB18868@prithivi.gnumonks.org&gt;
References: &lt;507EF747.805@fairwaves.ru&gt;
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Disposition: inline
Content-Transfer-Encoding: 8bit
In-Reply-To: &lt;507EF747.805@fairwaves.ru&gt;
User-Agent: Mutt/1.5.21 (2010-09-15)
Cc: Baseband Devel &lt;baseband-devel@lists.osmocom.org&gt;
X-BeenThere: baseband-devel@lists.osmocom.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: Development discussion about Osmocom BaseBand
	&lt;baseband-devel.lists.osmocom.org&gt;
List-Unsubscribe: &lt;https://lists.osmocom.org/mailman/options/baseband-devel&gt;, 
	&lt;mailto:baseband-devel-request@lists.osmocom.org?subject=unsubscribe&gt;
List-Archive: &lt;http://lists.osmocom.org/pipermail/baseband-devel&gt;
List-Post: &lt;mailto:baseband-devel@lists.osmocom.org&gt;
List-Help: &lt;mailto:baseband-devel-request@lists.osmocom.org?subject=help&gt;
List-Subscribe: &lt;https://lists.osmocom.org/mailman/listinfo/baseband-devel&gt;,
	&lt;mailto:baseband-devel-request@lists.osmocom.org?subject=subscribe&gt;
Sender: baseband-devel-bounces@lists.osmocom.org
Errors-To: baseband-devel-bounces@lists.osmocom.org

Hi Max,

On Wed, Oct 17, 2012 at 08:21:59PM +0200, ☎ wrote:

&gt; In &quot;struct mframe_sched_item&quot; in target/firmware/layer1/mframe_sched.c
&gt; both 'modulo' and 'frame_nr' defined as uint16_t. This seems like big
&gt; space waste considering tight memory environment we're working in.

On ARM, it doesn't matter.  even if you made those fields uint8_t
in the struct mframe_sched_item, they would still be aligned to 32bit
boundaries.  So you wouldn't change the memory layout at all based on
your change.

If you really wanted to save memory, then you would have to make the
struct packed.  This in turn would mean that accesses to the structure
members would be unaligned accesses, around which the compiler has to
work around by bit-shifting.

So you save some memory at the expense of increasing code size (and
execution time).

Given that the CPU speed is more limited than RAM, I think the current
approach makes sense.

&gt; Does structure alignment matters in this case? If so - how exactly?

see above.

&gt; Is it possible for 'modulo' to be bigger than 255?

I don't think so, at least not for standard GSM operation.

&gt; Is it possible for 'frame_nr' to be bigger than 255?

frame_nr can never be bigger than 'modulo'.

-- 
- Harald Welte &lt;laforge@gnumonks.org&gt;           http://laforge.gnumonks.org/
============================================================================
&quot;Privacy in residential applications is a desirable marketing option.&quot;
                                                  (ETSI EN 300 175-7 Ch. A6)


]